#pragma once
#include "common/types.h"

#define HASH_LENGTH	(1UL<<10)
#define DATA_BLOCK_SIZE	1

typedef struct _CDP_HASH_T{
	CDP_SUPER_BLOCK *bucket;
	int collisions;
	int insertions;
	int n;
	unsigned int total_write_count;
	__int64 data_len;
	__int64 parity_len;
	__int64 archive_len;
	struct _CDP_SUPER_BLOCK *ext;
} CDP_HASH_T,*PCDP_HASH_T;


int CDP_HashInit(CDP_HASH_T *h, int n);
int CDP_HashClose(CDP_HASH_T *h);
#ifdef CDP_NO_GAP
int CDP_HashInquiry(CDP_HASH_T *h, ULONG key, __int64 *data_offset, __int64 *parity_offset, __int64 *last_parity_offset=NULL,BOOL rw=false);
int CDP_HashInsert(CDP_HASH_T *h, ULONG key, __int64 *data_offset, __int64 *parity_offset, __int64 *last_parity_offset=NULL, BOOL rw=false);
#else
int CDP_HashInquiry(CDP_HASH_T *h, ULONG key, __int64 *data_offset, __int64 *parity_offset, BOOL rw=false, PCDP_SUPER_BLOCK *bucket=NULL);
int CDP_HashInsert(CDP_HASH_T *h, ULONG key, __int64 *data_offset, __int64 *parity_offset,BOOL rw=false);
#endif
int CDP_HashLoad(PCDP_HASH_T hash, int dev);
int CDP_HashSave(PCDP_HASH_T hash, int dev);

